/* AnimatorPan.c generated by valac 0.56.7, the Vala compiler
 * generated from AnimatorPan.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ANIMATOR_ACTION (animator_action_get_type ())
#define ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_ACTION, AnimatorAction))
#define ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_ACTION, AnimatorActionClass))
#define IS_ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_ACTION))
#define IS_ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_ACTION))
#define ANIMATOR_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_ACTION, AnimatorActionClass))

typedef struct _AnimatorAction AnimatorAction;
typedef struct _AnimatorActionClass AnimatorActionClass;
typedef struct _AnimatorActionPrivate AnimatorActionPrivate;
typedef enum  {
	ANIMATION_TYPE_UNKNOWN = 0,
	ANIMATION_TYPE_NODES,
	ANIMATION_TYPE_NODE,
	ANIMATION_TYPE_PAN,
	ANIMATION_TYPE_SCALE,
	ANIMATION_TYPE_PANSCALE
} AnimationType;

#define TYPE_ANIMATION_TYPE (animation_type_get_type ())

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_ANIMATOR_PAN (animator_pan_get_type ())
#define ANIMATOR_PAN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_PAN, AnimatorPan))
#define ANIMATOR_PAN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_PAN, AnimatorPanClass))
#define IS_ANIMATOR_PAN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_PAN))
#define IS_ANIMATOR_PAN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_PAN))
#define ANIMATOR_PAN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_PAN, AnimatorPanClass))

typedef struct _AnimatorPan AnimatorPan;
typedef struct _AnimatorPanClass AnimatorPanClass;
typedef struct _AnimatorPanPrivate AnimatorPanPrivate;
enum  {
	ANIMATOR_PAN_0_PROPERTY,
	ANIMATOR_PAN_NUM_PROPERTIES
};
static GParamSpec* animator_pan_properties[ANIMATOR_PAN_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _AnimatorAction {
	GObject parent_instance;
	AnimatorActionPrivate * priv;
	gchar* _name;
	gboolean _save;
	gint _id;
};

struct _AnimatorActionClass {
	GObjectClass parent_class;
	AnimationType (*type) (AnimatorAction* self);
	void (*capture) (AnimatorAction* self, DrawArea* da);
	void (*adjust) (AnimatorAction* self, DrawArea* da);
};

struct _AnimatorPan {
	AnimatorAction parent_instance;
	AnimatorPanPrivate * priv;
};

struct _AnimatorPanClass {
	AnimatorActionClass parent_class;
};

struct _AnimatorPanPrivate {
	gdouble* _sox;
	gdouble* _soy;
	gdouble* _eox;
	gdouble* _eoy;
};

static gint AnimatorPan_private_offset;
static gpointer animator_pan_parent_class = NULL;

VALA_EXTERN GType animator_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorAction, g_object_unref)
VALA_EXTERN GType animation_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType animator_pan_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorPan, g_object_unref)
VALA_EXTERN AnimationType animator_action_type (AnimatorAction* self);
VALA_EXTERN void animator_action_capture (AnimatorAction* self,
                              DrawArea* da);
VALA_EXTERN void animator_action_adjust (AnimatorAction* self,
                             DrawArea* da);
VALA_EXTERN AnimatorPan* animator_pan_new (DrawArea* da,
                               const gchar* name);
VALA_EXTERN AnimatorPan* animator_pan_construct (GType object_type,
                                     DrawArea* da,
                                     const gchar* name);
VALA_EXTERN AnimatorAction* animator_action_new (const gchar* name,
                                     gboolean save);
VALA_EXTERN AnimatorAction* animator_action_construct (GType object_type,
                                           const gchar* name,
                                           gboolean save);
VALA_EXTERN void draw_area_get_origin (DrawArea* self,
                           gdouble* x,
                           gdouble* y);
static gdouble* _double_dup (gdouble* self);
static AnimationType animator_pan_real_type (AnimatorAction* base);
static void animator_pan_real_capture (AnimatorAction* base,
                                DrawArea* da);
static void animator_pan_real_adjust (AnimatorAction* base,
                               DrawArea* da);
VALA_EXTERN gint animator_action_get_index (AnimatorAction* self);
VALA_EXTERN gdouble animator_action_get_frames (AnimatorAction* self);
VALA_EXTERN void animator_action_set_index (AnimatorAction* self,
                                gint value);
VALA_EXTERN void draw_area_set_origin (DrawArea* self,
                           gdouble x,
                           gdouble y);
static void animator_pan_finalize (GObject * obj);
static GType animator_pan_get_type_once (void);

static inline gpointer
animator_pan_get_instance_private (AnimatorPan* self)
{
	return G_STRUCT_MEMBER_P (self, AnimatorPan_private_offset);
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
	dup = g_new0 (gdouble, 1);
	memcpy (dup, self, sizeof (gdouble));
	return dup;
}

static gpointer
__double_dup0 (gpointer self)
{
	return self ? _double_dup (self) : NULL;
}

AnimatorPan*
animator_pan_construct (GType object_type,
                        DrawArea* da,
                        const gchar* name)
{
	AnimatorPan * self = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gdouble _tmp4_;
	gdouble* _tmp5_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (AnimatorPan*) animator_action_construct (object_type, name, FALSE);
	draw_area_get_origin (da, &_tmp0_, &_tmp1_);
	_g_free0 (self->priv->_sox);
	_tmp2_ = _tmp0_;
	_tmp3_ = __double_dup0 (&_tmp2_);
	self->priv->_sox = _tmp3_;
	_g_free0 (self->priv->_soy);
	_tmp4_ = _tmp1_;
	_tmp5_ = __double_dup0 (&_tmp4_);
	self->priv->_soy = _tmp5_;
	return self;
}

AnimatorPan*
animator_pan_new (DrawArea* da,
                  const gchar* name)
{
	return animator_pan_construct (TYPE_ANIMATOR_PAN, da, name);
}

static AnimationType
animator_pan_real_type (AnimatorAction* base)
{
	AnimatorPan * self;
	AnimationType result;
	self = (AnimatorPan*) base;
	result = ANIMATION_TYPE_PAN;
	return result;
}

static void
animator_pan_real_capture (AnimatorAction* base,
                           DrawArea* da)
{
	AnimatorPan * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gdouble _tmp4_;
	gdouble* _tmp5_;
	self = (AnimatorPan*) base;
	g_return_if_fail (da != NULL);
	draw_area_get_origin (da, &_tmp0_, &_tmp1_);
	_g_free0 (self->priv->_eox);
	_tmp2_ = _tmp0_;
	_tmp3_ = __double_dup0 (&_tmp2_);
	self->priv->_eox = _tmp3_;
	_g_free0 (self->priv->_eoy);
	_tmp4_ = _tmp1_;
	_tmp5_ = __double_dup0 (&_tmp4_);
	self->priv->_eoy = _tmp5_;
}

static void
animator_pan_real_adjust (AnimatorAction* base,
                          DrawArea* da)
{
	AnimatorPan * self;
	gdouble divisor = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gdouble origin_x = 0.0;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gdouble* _tmp8_;
	gdouble origin_y = 0.0;
	gdouble* _tmp9_;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	self = (AnimatorPan*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = animator_action_get_frames ((AnimatorAction*) self);
	_tmp3_ = _tmp2_;
	divisor = _tmp1_ / _tmp3_;
	_tmp4_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp5_ = _tmp4_;
	animator_action_set_index ((AnimatorAction*) self, _tmp5_ + 1);
	_tmp6_ = self->priv->_sox;
	_tmp7_ = self->priv->_eox;
	_tmp8_ = self->priv->_sox;
	origin_x = (*_tmp6_) + (((*_tmp7_) - (*_tmp8_)) * divisor);
	_tmp9_ = self->priv->_soy;
	_tmp10_ = self->priv->_eoy;
	_tmp11_ = self->priv->_soy;
	origin_y = (*_tmp9_) + (((*_tmp10_) - (*_tmp11_)) * divisor);
	draw_area_set_origin (da, origin_x, origin_y);
}

static void
animator_pan_class_init (AnimatorPanClass * klass,
                         gpointer klass_data)
{
	animator_pan_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AnimatorPan_private_offset);
	((AnimatorActionClass *) klass)->type = (AnimationType (*) (AnimatorAction*)) animator_pan_real_type;
	((AnimatorActionClass *) klass)->capture = (void (*) (AnimatorAction*, DrawArea*)) animator_pan_real_capture;
	((AnimatorActionClass *) klass)->adjust = (void (*) (AnimatorAction*, DrawArea*)) animator_pan_real_adjust;
	G_OBJECT_CLASS (klass)->finalize = animator_pan_finalize;
}

static void
animator_pan_instance_init (AnimatorPan * self,
                            gpointer klass)
{
	self->priv = animator_pan_get_instance_private (self);
	self->priv->_sox = NULL;
	self->priv->_soy = NULL;
	self->priv->_eox = NULL;
	self->priv->_eoy = NULL;
}

static void
animator_pan_finalize (GObject * obj)
{
	AnimatorPan * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANIMATOR_PAN, AnimatorPan);
	_g_free0 (self->priv->_sox);
	_g_free0 (self->priv->_soy);
	_g_free0 (self->priv->_eox);
	_g_free0 (self->priv->_eoy);
	G_OBJECT_CLASS (animator_pan_parent_class)->finalize (obj);
}

static GType
animator_pan_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AnimatorPanClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animator_pan_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimatorPan), 0, (GInstanceInitFunc) animator_pan_instance_init, NULL };
	GType animator_pan_type_id;
	animator_pan_type_id = g_type_register_static (TYPE_ANIMATOR_ACTION, "AnimatorPan", &g_define_type_info, 0);
	AnimatorPan_private_offset = g_type_add_instance_private (animator_pan_type_id, sizeof (AnimatorPanPrivate));
	return animator_pan_type_id;
}

GType
animator_pan_get_type (void)
{
	static volatile gsize animator_pan_type_id__once = 0;
	if (g_once_init_enter (&animator_pan_type_id__once)) {
		GType animator_pan_type_id;
		animator_pan_type_id = animator_pan_get_type_once ();
		g_once_init_leave (&animator_pan_type_id__once, animator_pan_type_id);
	}
	return animator_pan_type_id__once;
}

